/*************************************************************************
    tompeg.h

    03/02/08	Xiaohong
*************************************************************************/
#ifndef _INCLUDE_TOMPEG_H____________________________________
#define _INCLUDE_TOMPEG_H____________________________________
#define EXPORT extern "C" __declspec(dllexport)

#include <windows.h>
#include <vfw.h>

/**********************************************************
	R[obN֐ɓnvZXp[^
**********************************************************/
typedef enum
{
	TOMPEG_PROCESS_ENCODE_M1V = 0,	// 摜f[^ MPEG1 Ɉk
	TOMPEG_PROCESS_ENCODE_MP2,		// I[fBIf[^ MPEG2 Ɉk
	TOMPEG_PROCESS_COMBINE,			// MPEG1 2 
	TOMPEG_PROCESS_ELSE				// ̑
}TOMPEG_PROCESS_PARAM;
/**********************************************************
	G[R[h ̐錾
**********************************************************/
typedef enum
{
	TR_OK = 0,							// ɏI
	TR_CANCEL,							// [U[ɂ CANCEL ꂽ
	TR_ERR,								// \ȂG[
	TR_BITCOUNT_ERR,					// Ή̃rbg[h
	TR_BICOMPRESSION_ERR,				// ΉDIB COLOR MODE(ex.BI_BITFIELDS)
	TR_ERR_OPEN_FILE,					// t@CĴɎs
	TR_ERR_AUDIO_PARAM,					// uAudioLayerParam  1,2 ȊO̒lƂ
	TR_ERR_SYSTEM_BYTE_RATE_PARAM,		// uSystemByteRateParam  10 ȏ 5000 ȉłȂĂ͂ȂȂ
	TR_SEARCH_SIZE_ERR,					// nSearchSize  0 ȏ 4 ȉ̒lłȂĂ͂ȂȂ
	TR_FAST_MOTION_COMP_LEVEL_ERR,		// m_nFastMotionCompensationLevel  0 ȏ 4 ȉłȂĂ͂ȂȂ
	TR_AUDIO_BITRATE_ERR,				// w肳ꂽCɑ΂ărbg[gK؂łȂ
	TR_ERR_MAKE_CLIPPING_TABLE,			// ClippingTable ̍쐬Ɏs
	TR_ERR_ALLOC_FRAMES,				// t[i[p̊mۂɎs
	TR_ERR_ALLOC_BLOCK_INFO,			// ubNi[p̊mۂɎs
	TR_ERR_ALLOC_TEMP_UV_BUFFER,		// UV p̈ꎞ̊mۂɎs
	TR_ERR_ALLOC_BLOCK_ARRAY,			// ubNpz̃̊mۂɎs
	TR_WRSEQH2GOP_ERR,					// nWriteSequenceGrounp  0@ȉ̒l
	TR_FRAME_NUMBER_IN_GROOUP_ERR,
	TR_DISTANCE_BETWEEN_IP_FRAMES_ERR,
	TR_FNIG_MULTIPLE_DBIPF_ERR,
	TR_ERR_ALLOC_MOTION_STRUCT,			// i[p̊mۂɎs܂
	TR_HFRAME_SIZE_ERR,
	TR_CHROMA_FORMAT_ERR,
	TR_VFRAME_SIZE_ERR,
	TR_ASPECT_RATIO_ERR,
	TR_FRAME_RATE_CODE_ERR,
	TR_BITRATE_ERR,
	TR_VBV_BUFFER_SIZE_ERR,
	TR_VIDEO_FORMAT_ERR,
	TR_COLOR_PRIMARIES_ERR,
	TR_TRANSFER_CHARACTERISTICS_ERR,
	TR_MATRIX_COEFFICIENTS_ERR,
	TR_DISPLAY_HSIZE_ERR,
	TR_DISPLAY_VSIZE_ERR,
	TR_INTRA_DC_PRECISION_ERR,
	TR_FHCODE_ERR,
	TR_FVCODE_ERR,
	TR_SXF_ERR,
	TR_SYF_ERR,
	TR_BHCODE_ERR,
	TR_BVCODE_ERR,
	TR_SXB_ERR,
	TR_SYB_ERR,
	TR_DC_VALUE_OUT_OF_RANGE,
	TR_AC_VALUE_OUT_OF_RANGE,
	TR_AVISTREAMINFO_ERR,				// AVIStreamInfo Ɏs
	TR_AVISTREAMREADFORMAT_ERR,			// AVIStreamReadFormat Ɏs
	TR_NOT_PCM,							// PCM Ȃ
	TR_SAMPLE_PER_SEC_ERR,				// TvO[gɖ肠
	TR_BITS_PER_SAMPLE_ERR,				// rbg[gɖ肠
	TR_OPEN_TMP_AUDIO_FILE_ERR,
	TR_ALLOC_BIT_STREAM_BUFFER_ERR,
	TR_SAMPLING_FREQUENCY_ERR,
	TR_ERR_RENAME_TMP_FILE,
	TR_CHECK_FILE_ERR,
	TR_NO_SUPPORTED_AUDIO_LAYER,
	TR_I_MAIN_BIT_ALLOCATION_ERR,
	TR_II_MAIN_BIT_ALLOCATION_ERR,
	TR_HDR_TO_FRPS_ERR,
	TR_OUTPUT_VIDRO_ERR,


	// G[R[h̑
	TOMPGRET_ELEM_NUM
}TOMPGRET;

#define	TPG_AUDIO_LAYER_1 0
#define	TPG_AUDIO_LAYER_2 1
/**********************************************************
	TOMPEGFORMAT ̐錾
**********************************************************/
typedef struct
{
	PAVISTREAM pAudioStream;
	unsigned char uAudioLayerParam;		// 01	
	unsigned int uAudioBitrateParam;	// 128
	bool bJointStereoParam;
}TOMPEG_AUDIO_FORMAT;

typedef struct
{
	int nSearchSize;
	unsigned char* pQuantizerMatrix;	// 64 bit array
	unsigned char* pNonIntraMatrix;		// 64 bit array
	bool bUseImageNoiseReduction;
	unsigned int uSystemByteRateParam;	// 150
	unsigned int uLength;
	int nWriteSequenceGrounp;
	int nVBVBufferSize;
	int nFastMotionCompensationLevel;
	int nWidth,nHeight;
	int nScale,nRate;
	TOMPEG_AUDIO_FORMAT stAudioFormat;
}TOMPEG_VIDEO_FORMAT;

/**********************************************************
	֐ ̐錾
**********************************************************/
/*---------------------------------------------------------
	Cȕ
---------------------------------------------------------*/
EXPORT void CALLBACK TOMPEG_Init(void);

/*---------------------------------------------------------
	t@Cۑ
---------------------------------------------------------*/
EXPORT TOMPGRET CALLBACK TOMPEG_SaveAs(const char* szFile);

/*---------------------------------------------------------
	̃t[ԍԂ
---------------------------------------------------------*/
EXPORT int CALLBACK TOMPEG_NextFrame(void);

/*---------------------------------------------------------
	摜ǉ
---------------------------------------------------------*/
EXPORT TOMPGRET CALLBACK TOMPEG_AddFrame(const LPBITMAPINFO lpInfo,const unsigned char* pBytes);

/*---------------------------------------------------------
	쐬Jn
---------------------------------------------------------*/
EXPORT TOMPGRET CALLBACK TOMPEG_Start(const TOMPEG_VIDEO_FORMAT* pTompegVideoFormat,
									  const char* szTmpVideoPath,
									  const char* szTmpAudioPath,
									  bool(* CallBack)(TOMPEG_PROCESS_PARAM,int)=NULL);

/*---------------------------------------------------------
	I[fBIf[^̈k
---------------------------------------------------------*/
EXPORT TOMPGRET CALLBACK TOMPEG_PCM2MP(const char *tempfile,
										 const TOMPEG_AUDIO_FORMAT* pTompegAudioFormat,
										 bool(* CallBack)(TOMPEG_PROCESS_PARAM,int)=NULL);
/*---------------------------------------------------------
	I[fBIf[^ƃrfIf[^̓
---------------------------------------------------------*/
EXPORT TOMPGRET CALLBACK TOMPEG_ConvAudioAndVideo(const char *vfile,
												   const char *afile,
												   const char *mfile,
												   bool(* CallBack)(TOMPEG_PROCESS_PARAM,int)=NULL);
/*---------------------------------------------------------
	
---------------------------------------------------------*/
EXPORT void CALLBACK TOMPEG_Clear(void);
#endif