/*************************************************************************
    INITS.cpp

    03/02/08	Xiaohong
*************************************************************************/
#include "inits.h"
#include <windows.h>
/*************************************************************************
	Initialisieren von Strukturen fuer S*N cc Compiler.

	Initialize structs for S*N cc compiler.
*************************************************************************/

Vaunit_struc::Vaunit_struc()
{
	empty();
}
void Vaunit_struc::empty(void)
{
	length = 0;
	type = 0;
	DTS.empty();
	PTS.empty();
}
void Vaunit_struc::write_file(HANDLE hFile)
{
	DWORD dwResult;
	WriteFile(hFile,&length,sizeof(length),&dwResult,NULL);
	WriteFile(hFile,&type,sizeof(type),&dwResult,NULL);
//	fwrite(&length,1,sizeof(length),fp);
//	fwrite(&type,1,sizeof(type),fp);
	DTS.write_file(hFile);
	PTS.write_file(hFile);
}
bool Vaunit_struc::read_file(HANDLE hFile)
{
	//if(fread(&length,1,sizeof(length),fp) == sizeof(length)
	//	&& fread(&type,1,sizeof(type),fp) == sizeof(type)
	DWORD dwResult = 0;
	ReadFile(hFile,&length,sizeof(length),&dwResult,NULL);
	if(dwResult<sizeof(length))
		return false;

	dwResult = 0;
	ReadFile(hFile,&type,sizeof(type),&dwResult,NULL);
	if(dwResult<sizeof(type))
		return false;

	if(DTS.read_file(hFile)
		&& PTS.read_file(hFile))
	{
		return true;
	}
	return false;
}

Aaunit_struc::Aaunit_struc()
{
	empty();
}
void Aaunit_struc::empty(void)
{
	length = 0;
	PTS.empty();
}
void Aaunit_struc::write_file(HANDLE hFile)
{
	DWORD dwResult;
	WriteFile(hFile,&length,sizeof(length),&dwResult,NULL);
//	fwrite(&length,1,sizeof(length),fp);
	PTS.write_file(hFile);
}
bool Aaunit_struc::read_file(HANDLE hFile)
{
//	if(fread(&length,1,sizeof(length),fp) == sizeof(length)
	DWORD dwResult = 0;
	ReadFile(hFile,&length,sizeof(length),&dwResult,NULL);
	if(dwResult<sizeof(length))
		return false;

	return PTS.read_file(hFile);
}


void empty_video_struc (Video_struc* pointer)
{
    int i;

    pointer->stream_length	= 0;
    pointer->num_sequence 	= 0;
    pointer->num_seq_end	= 0;
    pointer->num_pictures 	= 0;
    pointer->num_groups   	= 0;
    for (i=0; i<4; i++)
    {
        pointer->num_frames[i] 	= 0;
        pointer->avg_frames[i]	= 0;
    }
    pointer->horizontal_size 	= 0;
    pointer->vertical_size	= 0;
    pointer->aspect_ratio 	= 0;
    pointer->picture_rate 	= 0;
    pointer->bit_rate		= 0;
    pointer->comp_bit_rate	= 0;
    pointer->vbv_buffer_size	= 0;
    pointer->CSPF		= 0;
}

void empty_audio_struc (Audio_struc* pointer)
{   
    int i;

    pointer->stream_length 	= 0;
    pointer->num_syncword 	= 0;
    for (i=0; i<2; i++)
    {
        pointer->num_frames [i]	= 0;
        pointer->size_frames[i]	= 0;
    }
    pointer->layer		= 0;
    pointer->protection 	= 0;
    pointer->bit_rate 		= 0;
    pointer->frequency 		= 0;
    pointer->mode 		= 0;
    pointer->mode_extension 	= 0;
    pointer->copyright      	= 0;
    pointer->original_copy  	= 0;
    pointer->emphasis		= 0;
}

void empty_sector_struc(Sector_struc* pointer)
{
    pointer->length_of_sector  = 0;
    pointer->length_of_packet_data  = 0;
    pointer->TS.empty();
}


void init_buffer_struc(Buffer_struc* pointer,unsigned int size)
{
    pointer->max_size = size;
    pointer->first = NULL;
}
