/*************************************************************************
    buffer.h

    03/02/08	Xiaohong
*************************************************************************/
#ifndef _INCLUDE_BUFFER_H___________________________________
#define _INCLUDE_BUFFER_H___________________________________

#include "timecode.h"

class Buffer_queue	/* FIFO-Queue fuer STD Buffer		*/
{
public:
	Buffer_queue(const unsigned int);

	unsigned int size;	/* als verkettete Liste implementiert	*/
    Timecode_struc DTS;
    Buffer_queue *next;
};

class Buffer_struc	/* Simuliert STD Decoder Buffer		*/
{
public:
	Buffer_struc();
	~Buffer_struc();
	void clean(Timecode_struc* SCR);
	unsigned int space(void);
	bool queue(const unsigned int bytes,Timecode_struc* TS);

	unsigned int max_size;	/* enthaelt Anker auf verkettete Liste	*/
    Buffer_queue *first;
};
#endif