/*************************************************************************
    systemdata.h

    03/02/08	Xiaohong
*************************************************************************/
#ifndef _INCLUDE_SYSTEMDATA_H_____________________________
#define _INCLUDE_SYSTEMDATA_H_____________________________

#include <windows.h>

/**********************************************************
	SYSTEMDATA ̐錾
**********************************************************/
class SYSTEMDATA
{
public:
	SYSTEMDATA();
	~SYSTEMDATA();

	bool OpenOutFile(const char*);
	void CloseOutFile(void);

	void initbits(void);
	void flushbits(void);
	void putbits(const int,const int);
	void alignbits(void);

	inline int bitcount(void)
	{
		return 8*m_nByteCnt + (8-m_nOutCnt);
	}

private:

	HANDLE m_pOutFile;

	unsigned char m_uOutBfr;
	int m_nOutCnt;
	int m_nByteCnt;
	int m_nFreeSpace;				/* free space (bytes) into the buffer */
	unsigned char *m_pBufPtr;		/* pointer on current byte into the buffer */
	unsigned char m_aBuffer[65536];	/* a buffer of 64KB */
};

#endif